"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@nodeswork/utils");
const components_1 = require("../components");
class NodesworkAccountManager extends components_1.BaseComponentManager {
    constructor() {
        super(...arguments);
        this.classMap = {};
    }
    register(clazz, options, overwrite = false) {
        super.register(clazz, options, overwrite);
        this.classMap[clazz.name] = [clazz, options];
    }
    async parseAccounts(ctx, accounts = []) {
        for (let account of accounts) {
            let accountType = account.accountType;
            utils_1.validator.isRequired(accountType, {
                message: 'Missing account class',
                meta: {
                    accountType: accountType,
                },
            });
            utils_1.validator.isRequired(this.classMap[accountType], {
                message: 'Missing account class',
                meta: {
                    accountType: accountType,
                },
            });
            let [clazz, options] = this.classMap[accountType];
            account.__proto__ = Object.create({
                ctx: ctx,
            }, clazz.prototype);
        }
        return accounts;
    }
}
exports.NodesworkAccountManager = NodesworkAccountManager;

//# sourceMappingURL=account-manager.js.map
