import * as Koa from "koa";
import { Nodeswork } from '../nodeswork';
import { NodesworkComponent, NodesworkComponentOption } from '../components';
export interface AccountActionOption {
    action: string;
    params: {};
}
export interface AccountKoaContext extends Koa.Context {
    executionId: string;
}
export interface NodesworkAccountClass {
    new (): NodesworkAccount<AccountKoaContext>;
    initialize(options: NodesworkAccountOption): Promise<void>;
    initialized(options: NodesworkAccountOption): Promise<void>;
}
export interface NodesworkAccountOption extends NodesworkComponentOption {
}
export declare class NodesworkAccount<AT extends AccountKoaContext> extends NodesworkComponent<AT> {
    _id: string;
    ctx: AT;
    nodeswork: Nodeswork;
    /**
     * Initialize current account.
     */
    init(): Promise<void>;
    /**
     * Take action on current account.
     */
    action(options: AccountActionOption): Promise<any>;
    getComponent<T extends NodesworkComponent<Koa.Context>>(name: string): T;
    /**
     * Intialize current account when nodeswork starts.
     */
    static initialize(options: NodesworkAccountOption): Promise<void>;
    /**
     * A second round of intialization for dealing with account dependencies.
     */
    static initialized(options: NodesworkAccountOption): Promise<void>;
}
