"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@nodeswork/utils");
const components_1 = require("../components");
class NodesworkAccount extends components_1.NodesworkComponent {
    /**
     * Initialize current account.
     */
    async init() {
    }
    /**
     * Take action on current account.
     */
    async action(options) {
        let action = options.action;
        let request = this.getComponent('request');
        return await request.post({
            url: `/api/v1/executions/${this.ctx.executionId}/accounts/${this._id}/action`,
            body: options,
        });
    }
    getComponent(name) {
        let ret = this.ctx.components[name];
        utils_1.validator.isRequired(ret, {
            meta: {
                path: `ctx.components.${name}`,
            },
        });
        return ret;
    }
    /**
     * Intialize current account when nodeswork starts.
     */
    static async initialize(options) {
    }
    /**
     * A second round of intialization for dealing with account dependencies.
     */
    static async initialized(options) {
    }
}
exports.NodesworkAccount = NodesworkAccount;

//# sourceMappingURL=account.js.map
