import * as Koa from "koa";
import { Nodeswork } from '../nodeswork';
import { NodesworkComponentClass, NodesworkComponentOption, NodesworkComponentMap } from './component';
export declare abstract class BaseComponentManager<CC extends NodesworkComponentClass, CO extends NodesworkComponentOption> {
    nodeswork: Nodeswork;
    classes: Array<[CC, CO]>;
    constructor(nodeswork: Nodeswork);
    /**
     * Register a new component class.
     */
    register(cls: CC, options: CO, overwrite?: boolean): void;
    /**
     * Initialize registered components.
     */
    initialize(): Promise<void>;
    /**
     * Call second round of initialized for registered components.
     */
    initialized(): Promise<void>;
}
export declare class NodesworkComponentManager extends BaseComponentManager<NodesworkComponentClass, NodesworkComponentOption> {
    getComponentMap(ctx: Koa.Context): NodesworkComponentMap;
}
