"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@nodeswork/utils");
class NodesworkComponent {
    constructor(ctx) {
        this.ctx = ctx;
    }
    /**
     * Depends on another component.
     *
     * @param {string} name - name of the component which current component
     * depends on.
     * @throws {NodesworkError} when the dependency is missing.
     * @return {NodesworkComponent}
     */
    depends(name) {
        let res = this.ctx.components[name];
        utils_1.validator.isRequired(res, { meta: {
                path: `ctx.components.${name}`,
                hints: `Ensure component ${name} is imported`,
            } });
        return res;
    }
    /**
     * Intialize current component when nodeswork starts.
     */
    static async initialize(options) {
    }
    /**
     * A second round of intialization for dealing with component dependencies.
     */
    static async initialized(options) {
    }
}
exports.NodesworkComponent = NodesworkComponent;

//# sourceMappingURL=component.js.map
