import * as Koa from "koa";
import { NodesworkComponent, NodesworkComponentOption } from './component';
export interface LoggerKoaContext extends Koa.Context {
    logKey: string;
    requestLog: any;
}
export interface LoggerClass {
    new (ctx: LoggerKoaContext): Logger;
}
export declare class Logger extends NodesworkComponent<LoggerKoaContext> {
    private getMeta(meta);
    request(data: {}): void;
    debug(message: string, meta?: {}): void;
    verbose(message: string, meta?: {}): void;
    info(message: string, meta?: {}): void;
    warn(message: string, meta?: {}): void;
    error(message: string, meta?: {}): void;
    static initialize(options: NodesworkComponentOption): Promise<void>;
    static initialized(options: NodesworkComponentOption): Promise<void>;
}
