"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("underscore");
const component_1 = require("./component");
class Request extends component_1.NodesworkComponent {
    constructor(ctx) {
        super(ctx);
        this.logger = this.depends('logger');
    }
    async get(options) {
        return this.request(_.extend({}, options, {
            method: 'GET',
        }));
    }
    async post(options) {
        return this.request(_.extend({}, options, {
            method: 'POST',
        }));
    }
    async request(options) {
        let startTime = Date.now();
        try {
            let res = await this.nodeswork.request(options);
            this.logger.debug('Send request success', {
                options,
                duration: Date.now() - startTime,
            });
            return res;
        }
        catch (e) {
            this.logger.error('Send request failed', {
                options,
                duration: Date.now() - startTime,
            });
            throw e;
        }
    }
}
exports.Request = Request;

//# sourceMappingURL=request.js.map
