"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger = require("@nodeswork/logger");
const utils_1 = require("@nodeswork/utils");
const middleware_1 = require("../middleware");
const LOG = logger.getLogger();
let ErrorHandleMiddleware = class ErrorHandleMiddleware {
    constructor() {
        this.handleError = async (ctx, next) => {
            try {
                await next();
            }
            catch (e) {
                const err = utils_1.NodesworkError.cast(e);
                ctx.status = err.meta.responseCode;
                ctx.body = err.toJSON();
                if (err.meta.responseCode >= 500) {
                    LOG.error('5xx in request', err.toJSON({ cause: true, stack: true }));
                }
                else if (err.meta.responseCode >= 400) {
                    LOG.warn('4xx in request', err.toJSON());
                }
            }
        };
        this.uncaughtRequest = async (ctx) => {
            throw utils_1.NodesworkError.notFound(undefined, {
                path: ctx.request.path,
                method: ctx.request.method,
            });
        };
    }
};
__decorate([
    middleware_1.AppMiddleware(),
    __metadata("design:type", Object)
], ErrorHandleMiddleware.prototype, "handleError", void 0);
__decorate([
    middleware_1.AppMiddleware({ later: true }),
    __metadata("design:type", Object)
], ErrorHandleMiddleware.prototype, "uncaughtRequest", void 0);
ErrorHandleMiddleware = __decorate([
    middleware_1.MiddlewareProvider()
], ErrorHandleMiddleware);
exports.ErrorHandleMiddleware = ErrorHandleMiddleware;

//# sourceMappingURL=error.handle.middleware.js.map
