"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger = require("@nodeswork/logger");
const module_1 = require("../module");
const providers_1 = require("../providers");
const middlewares_1 = require("../middlewares");
const handlers_1 = require("../handlers");
const inputs_1 = require("../inputs");
const LOG = logger.getLogger();
let CoreModule = class CoreModule {
    constructor(koa) {
        this.koa = koa;
        this.koa.app.listen(28900);
        LOG.info('server is start', { url: 'http://localhost:28900' });
    }
};
CoreModule = __decorate([
    module_1.Module({
        middlewares: [
            middlewares_1.BodyParserMiddleware,
            middlewares_1.ErrorHandleMiddleware,
        ],
        handlers: [
            handlers_1.ServiceHandler,
        ],
        inputs: [
            inputs_1.ContextInputProvider,
        ],
        providers: [
            inputs_1.ContextInput,
            providers_1.ModuleService,
            providers_1.KoaService,
        ],
    }),
    __metadata("design:paramtypes", [providers_1.KoaService])
], CoreModule);
exports.CoreModule = CoreModule;

//# sourceMappingURL=core.module.js.map
