// Generated by CoffeeScript 2.0.0-beta5
(function() {
  var API_PREFIX, Messager, NodesworkComponent, _, validator;

  _ = require('underscore');

  ({validator} = require('@nodeswork/utils'));

  ({NodesworkComponent} = require('../components/component'));

  ({API_PREFIX} = require('../constants'));

  // Messager is the component to send message to the current user.
  Messager = class Messager extends NodesworkComponent {
    constructor(ctx) {
      super(ctx);
      ({user: this.user, applet: this.applet} = ctx);
      this.request = this.depends('request');
    }

    // Send message to user's message inbox.

    // @option opts {String} message the message to send.
    // @return {Promise<Message>}
    sendMessage(opts) {
      var message, url;
      validator.isRequired(this.user, {
        meta: {
          path: 'ctx.user'
        }
      });
      validator.isRequired(this.applet, {
        meta: {
          path: 'ctx.applet'
        }
      });
      if (_.isString(opts)) {
        opts = {
          message: opts
        };
      }
      ({message} = opts);
      url = `${API_PREFIX}/applet-api/${this.applet._id}/users/${this.user._id}/messages`;
      return this.request.post({
        url: url,
        body: {
          message: message
        }
      });
    }

  };

  module.exports = {Messager};

}).call(this);
