// Generated by CoffeeScript 2.0.0-beta5
(function() {
  var Case, NodesworkComponent, Resource, Resources, URL, _, base, base1, transformResponse, transformUrl,
    indexOf = [].indexOf;

  _ = require('underscore');

  Case = require('case');

  ({URL} = require('url'));

  // deepcopy                = require 'deepcopy'
  ({NodesworkComponent} = require('../components/component'));

  if ((base = Function.prototype).getter == null) {
    base.getter = function(prop, get) {
      return Object.defineProperty(this.prototype, prop, {
        get,
        configurable: true
      });
    };
  }

  if ((base1 = Function.prototype).setter == null) {
    base1.setter = function(prop, set) {
      return Object.defineProperty(this.prototype, prop, {
        set,
        configurable: true
      });
    };
  }

  Resource = class Resource {
    constructor(doc) {
      _.extend(this, doc);
    }

    static initialize(options1) {
      var action, i, len, options, ref, results;
      this.options = options1;
      this.options.actions = _.defaults(this.options.actions, {
        create: {
          method: 'POST',
          isArray: false
        },
        query: {
          method: 'GET',
          isArray: true
        },
        get: {
          method: 'GET',
          isArray: false
        },
        save: {
          method: 'POST',
          isArray: false
        },
        delete: {
          method: 'DELETE',
          isArray: false
        }
      });
      ref = _.keys(this.options.actions);
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        action = ref[i];
        options = this.getOption(action);
        results.push(((options) => {
          this[action] = async function(params) {
            var opt, requestOpts, res;
            opt = deepcopy(options);
            _.extend(opt.params, params);
            requestOpts = {
              url: transformUrl(opt.url, opt.params, true),
              method: opt.method,
              headers: opt.headers
            };
            res = (await this.ctx.components.request.request(requestOpts));
            return transformResponse(this, res, opt);
          };
          return this.prototype[`$${action}`] = function() {};
        })(options));
      }
      return results;
    }

    static getOption(action) {
      var ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9;
      return {
        url: (ref = (ref1 = this.options[action]) != null ? ref1.url : void 0) != null ? ref : this.options.url,
        method: (ref2 = (ref3 = this.options[action]) != null ? ref3.method : void 0) != null ? ref2 : 'GET',
        params: (ref4 = (ref5 = (ref6 = this.options[action]) != null ? ref6.params : void 0) != null ? ref5 : this.options.params) != null ? ref4 : {},
        isArray: (ref7 = (ref8 = this.options[action]) != null ? ref8.isArray : void 0) != null ? ref7 : false,
        headers: _.extend({}, (ref9 = this.options[action]) != null ? ref9.headers : void 0, this.options.headers)
      };
    }

  };

  Resources = class Resources extends NodesworkComponent {
    constructor(ctx) {
      super(ctx);
      this.request = this.depends('request');
      this.cache = {};
    }

    // Define a new resource.

    // @param {String} name
    // @option options {String} url
    // @option options {Object} params
    // @option options {Object} actions
    static define(name, options) {
      return this.getter(name, function() {
        var NResource, SResource;
        if (!this.cache[name]) {
          NResource = class NResource extends Resource {};
          NResource.initialize(options);
          this.cache[name] = NResource;
        }
        SResource = class SResource extends this.cache[name] {};
        Object.defineProperty(SResource, 'name', {
          get: function() {
            return name;
          }
        });
        Object.defineProperty(SResource, 'ctx', {
          get: () => {
            return this.ctx;
          }
        });
        return SResource;
      });
    }

  };

  transformUrl = function(url, params, isGet = false) {
    var fetchFromParams, name, searchParams, u, usedNames, val;
    usedNames = [];
    fetchFromParams = function(match, name) {
      var ref;
      usedNames.push(name);
      return (ref = params[name]) != null ? ref : '';
    };
    u = new URL(url);
    u.pathname = u.pathname.replace(/:(\w+)/g, fetchFromParams);
    if (isGet) {
      searchParams = u.searchParams;
      for (name in params) {
        val = params[name];
        if (indexOf.call(usedNames, name) < 0) {
          searchParams.set(name, val);
        }
      }
    }
    return u.href;
  };

  transformResponse = function(cls, res, options) {
    if (options.isArray) {
      return _.map(res, function(r) {
        return new cls(r);
      });
    } else {
      return new cls(res);
    }
  };

  module.exports = {Resources};

}).call(this);
